
/**
 * Beschreibt das Abschlusselement des Baums.
 * 
 * @author Arbeitskreis
 * @version 1.0
 */
class ABSCHLUSS extends BAUMELEMENT
{

    /**
     * In der Klasse ABSCHLUSS fallen keine speziellen Initialisierungen an.
     */
    ABSCHLUSS()
    {
        super ();
    }

    /**
     * Sucht im Baum nach dem gegebenen Datenelelement.
     * @param wert Referenz auf ein Datenelement mit dem Vergleichswert
     * @return Referenz auf das Datenelement, wenn der Wert gefunden wurde<br>null: sonst
     */
    DATENELEMENT Suchen (DATENELEMENT wert)
    {
        return null;
    }

    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * Der Wert darf noch nicht vorkommen
     * @param wert Referenz auf das einzuf&uuml;gende Datenelement
     * @return der (neue) Nachfolger des Aufrufers
     */
    BAUMELEMENT Einfuegen (DATENELEMENT wert)
    {
        return new KNOTEN (wert);
    }
    
    /**
     * Durchl&auml;ft den Baum in Preorder
     */
    void PreOrder ()
    {
    }
    
    /**
     * Durchl&auml;ft den Baum in Inorder
     */
    void InOrder ()
    {
    }
    
    /**
     * Durchl&auml;ft den Baum in Postorder
     */
    void PostOrder ()
    {
    }

    /**
     * Entfernt den Knoten mit der Referenz auf das Datenelement mit dem gegebenen Schl&uuml;ssel.
     * @param wert Referenz auf ein Datenelement mit dem Schl&uuml;sselwert
     * @return der (neue) Nachfolger des Aufrufers
     */
    BAUMELEMENT Entfernen (DATENELEMENT wert)
    {
        System. out. print ("Der zu entfernende Wert wurde nicht gefunden: ");
        wert. Ausgeben ();
        return this;
    }
    
    /**
     * F&uuml;gt den angegebenen Teilbaum an der am weitesten rechts stehenden Stelle ein.
     * @param teil der Anzuf&uuml;gende Teilbaum
     * @return der (neue) Nachfolger des Aufrufers
     */
    protected BAUMELEMENT AnfuegenRechts (BAUMELEMENT teil)
    {
        return teil;
    }
}
