
/**
 * Verwaltet den Baum als Ganzes.
 * 
 * @author Arbeitskreis
 * @version 1.0
 */
class BAUM
{
    /** Referenz auf die Wurzel des Baums */
    private BAUMELEMENT wurzel;

    /**
     * Legt einen leeren Baum an.
     */
    BAUM()
    {
        wurzel = new ABSCHLUSS ();
    }

    /**
     * Sucht im Baum nach dem gegebenen Datenelelement.
     * @param wert Referenz auf ein Datenelement mit dem Vergleichswert
     * @return Referenz auf das Datenelement, wenn der Wert gefunden wurde<br>null: sonst
     */
    DATENELEMENT Suchen (DATENELEMENT wert)
    {
        return wurzel. Suchen (wert);
    }
    
    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * Der Wert darf noch nicht vorkommen
     * @param wert Referenz auf das einzuf&uuml;gende Datenelement
     */
    void Einfuegen (DATENELEMENT wert)
    {
        wurzel = wurzel. Einfuegen (wert);
    }
    
    /**
     * Durchl&auml;ft den Baum in Preorder
     */
    void PreOrder ()
    {
        wurzel. PreOrder ();
    }
    
    /**
     * Durchl&auml;ft den Baum in Inorder
     */
    void InOrder ()
    {
        wurzel. InOrder ();
    }
    
    /**
     * Durchl&auml;ft den Baum in Postorder
     */
    void PostOrder ()
    {
        wurzel. PostOrder ();
    }

    /**
     * Entfernt den Knoten mit der Referenz auf das Datenelement mit dem gegebenen Schl&uuml;ssel.
     * @param wert Referenz auf ein Datenelement mit dem Schl&uuml;sselwert
     */
    void Entfernen (DATENELEMENT wert)
    {
        wurzel = wurzel. Entfernen (wert);
    }
}
