
/**
 * Beschreibt ein allgemeines Element des Baums.
 * 
 * @author Arbeitskreis
 * @version 1.0
 */
abstract class BAUMELEMENT
{

    /**
     * Der Konstruktor ist aus Dokumentationsgr&uuml;nden vorhanden
     */
    BAUMELEMENT()
    {
        // keine spezielle Aufgabe
    }

    /**
     * Sucht im Baum nach dem gegebenen Datenelelement.
     * @param wert Referenz auf ein Datenelement mit dem Vergleichswert
     * @return Referenz auf das Datenelement, wenn der Wert gefunden wurde<br>null: sonst
     */
    abstract DATENELEMENT Suchen (DATENELEMENT wert);

    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * Der Wert darf noch nicht vorkommen
     * @param wert Referenz auf das einzuf&uuml;gende Datenelement
     * @return der (neue) Nachfolger des Aufrufers
     */
    abstract BAUMELEMENT Einfuegen (DATENELEMENT wert);
    
    /**
     * Durchl&auml;ft den Baum in Preorder
     */
    abstract void PreOrder ();
    
    /**
     * Durchl&auml;ft den Baum in Inorder
     */
    abstract void InOrder ();
    
    /**
     * Durchl&auml;ft den Baum in Postorder
     */
    abstract void PostOrder ();

    /**
     * Entfernt den Knoten mit der Referenz auf das Datenelement mit dem gegebenen Schl&uuml;ssel.
     * @param wert Referenz auf ein Datenelement mit dem Schl&uuml;sselwert
     * @return der (neue) Nachfolger des Aufrufers
     */
    abstract BAUMELEMENT Entfernen (DATENELEMENT wert);
    
    /**
     * F&uuml;gt den angegebenen Teilbaum an der am weitesten rechts stehenden Stelle ein.
     * @param teil der Anzuf&uuml;gende Teilbaum
     * @return der (neue) Nachfolger des Aufrufers
     */
    abstract protected BAUMELEMENT AnfuegenRechts (BAUMELEMENT teil);
}
