
/**
 * Datenelemente f&uuml;r ein W&ouml;rterbuch.
 * 
 * @author Arbeitskreis
 * @version 1.0
 */

import java. text. Collator;
class WORT implements DATENELEMENT
{
    /** Der englische Suchbegriff */
    private String englisch;
    /** Die deutschen Entsprchungen */
    private String deutsch;
    /** Vergleichsobjekt */
    private Collator coll;
    
    /**
     * Legt das Datenelement mit dem gegebenen Wert an.
     * @param w Wert des Datenelements
     */
    WORT(String e, String d)
    {
        englisch = e;
        deutsch = d;
        coll = Collator. getInstance ();
    }
    
    /**
     * Vergleicht das vorhandene Datenelement mit dem &uuml;bergebenen.
     * @param wert der Vergleichswert
     * @return -1: das aktuelle Element ist kleiner als das Vergleichselement<br>
     *          0: das aktuelle Elelemt hat den gleichen Wert wie das Vergleichselement<br>
     *          1: das aktuelle Element ist gr&ouml;&szlig;er als das Vergleichselement
     */
    public int Vergleichen (DATENELEMENT wert)
    {
        return coll. compare (englisch, ((WORT) wert). englisch);
    }
    
    /**
     * Gibt die relevante Information des Datenelements auf die Konsole aus.
     */
    public void Ausgeben ()
    {
        System. out. println ("Das englische Wort: " + englisch + " bedeutet im Deutschen: " + deutsch);
    }
}
