
/**
 * Angaben &uuml;ber ein einzelnes Aktienpaket.
 * 
 * @author
 * @version 1.0
 */
class AKTIENPAKET
{
    private int anzahl;
    private int paketNummer;
    private String aktienName;
    private int aktienID;
    private double kaufKurs;
    private String kaufDatum;

    /**
     * Besetzt die Attribute vor.
     * @param paketNummer laufende Nummer des Aktienpakets
     * @param anzahl Anzahl der Aktien im Paket
     * @aktienName Name der Aktie
     */
    AKTIENPAKET (int paketNummer, int anzahl, String aktienName, int aktienID, double kaufKurs, String kaufDatum)
    {
        this. anzahl = anzahl;
        this. paketNummer = paketNummer;
        this. aktienName = aktienName;        
        this. aktienID = aktienID;
        this. kaufKurs = kaufKurs;
        this. kaufDatum = kaufDatum;        
    }
   
    /**
     * St&uuml;ckzahl erh&ouml;hen
     * @param stueckzahl Anzahl der hinzukommenden Aktien
     */
    void AnzahlErhoehen (int stueckzahl)
    {
        anzahl += stueckzahl;
    }
    
    /**
     * St&uuml;ckzahl verringern
     * @param stueckzahl Anzahl der abgehenden Aktien
     */
    void AnzahlVerringern (int stueckzahl)
    {
        anzahl -= stueckzahl;
    }
    
    /** 
     * Anzeigedaten als String melden
     * @return Daten in der Reihenfolge PaketNummer, Name, Anzahl
     */
    String AnzeigedatenGeben ()
    {
       return ""+ paketNummer + " " + aktienName + " " + anzahl;
    } 
    
    /**
     * Paketnummer melden
     * @return Nummer des Aktienpaketes
     */
    int PaketNummerGeben ()
    {
        return paketNummer;
    }
    
    /**
     * Anzahl melden
     * @return Anzahl der Aktien im Paketes
     */
    int AnzahlGeben ()
    {
        return anzahl;
    }
    
    /**
     * Namen melden
     * @return Namen der Aktien im Paketes
     */
    String AktiennameGeben ()
    {
        return aktienName;
    }
    
    /**
     * Aktiennummer melden
     * @return Nummer der Aktien im Paketes
     */
    int AktiennummerGeben ()
    {
        return aktienID;
    }
    
    /**
     * Kaufkurs melden
     * @return Kaufkurs der Aktien im Paketes
     */
    double KaufKursGeben ()
    {
        return kaufKurs;
    }
    
    /**
     * KaufDatum melden
     * @return KaufDatum der Aktien im Paketes
     */
    String KaufDatumGeben ()
    {
        return kaufDatum;
    }
}
