
/**
 * Beschreibt die f&uuml;r die Oberfl&auml;che n&ouml;tigen Methoden des Kontrolleurs.
 * 
 * @author 
 * @version 1.0
 */

interface KONTROLLEURINTERFACE
{
    /**
     * Setzt des aktuelle Konto anhand der gegebenen Kontonummer
     * @param nummer neue Kontonummer
     */
    void KontoSetzen (int nummer);

    /**
     * Ereignis "Aktien einkaufen"
     * @param aktienID Schl&uuml;ssel der Aktie
     * @param anzahl gew&uuml;nschte Anzahl der Aktie
     */
    void AktienKaufen (int aktienID, int anzahl);

    /**
     * Ereignis "Aktien verkaufen"
     * @param aktienID Schl&uuml;ssel der Aktie
     * @param anzahl gew&uuml;nschte Anzahl der Aktie
     */
    void AktienVerkaufen (int aktienID, int anzahl);

    /**
     * Ereignis "Kursverlauf anzeigen"
     * @param aktienID Schl&uuml;ssel der Aktie
     */
    void KursverlaufAnzeigen (int aktienID);
    
    /**
     * Ereignis "neue Kurse"
     */
    void NeueKurswerteBerechnen ();
    
    /**
     * Ereignis "Ende"
     */
    void Beenden ();
    
    /**
     * Inhalt f&uuml;r die Aktienliste besorgen
     */
    String [] AktienNamenGeben ();

    /**
     * Holt die Nummern aller Konten
     * @return Feld mit den Kontonummern
     */
    int [] KontennummernGeben ();
}
