
/**
 * Allgemeines Element einer Liste von Konten
 * 
 * @author
 * @version 1.0
 */
abstract class LISTENELEMENT
{
    /**
     * Der Konstruktor ist nur der Vollst&auml;ndigkeit halber angegeben.
     */
    LISTENELEMENT ()
    {
        // (noch) nichts zu tun
    }

    /**
     * F&uuml;gt ein Konto sortiert nach Kontonummern in die Liste ein.
     * @param konto Referenz auf das einzuf&uuml;gende Konto.
     * @return (neues) Nachfolgeelement des Aufrufers.
     */
    abstract LISTENELEMENT Einfuegen (KONTO konto);
    
    /**
     * Sucht das angegebene Konto.
     * Nutzt die Sortierung der Liste aus.
     * @param nummer Nummer des zu suchenden Kontos.
     * @return Referenz auf das gefundene Konto oder null.
     */
    abstract KONTO Suchen (int nummer);
    
    /**
     * Z&auml;hlt die Konten, die der angegebene Kunde besitzt.
     * @return Anzahl der Mitglieder der Menge.
     */
    abstract int KontosZaehlen ();
    
    /**
     * Tr&auml;gt die Kontonummern der Konten des angegebenen Kunden in das Feld ein.
     * @param ergebnis Referenz auf das Feld mit den gefundenen Daten.
     * @param pos Index, auf dem das n&auml;chste Element eingetragen werden soll.
     */
    abstract void KontonummernEintragen (int [] ergebnis, int pos);
}
