
/**
 * Abschlussknoten einer Liste von Datenelementen.
 * 
 * @author 
 * @version 1.0
 */
class ABSCHLUSS extends LISTENELEMENT
{
    
    /**
     * Belegt die Attribute.
     */
    ABSCHLUSS ()
    {
        super ();
    }
    
    /**
     * F&uuml;gt das Datenelement als letztes in die Liste ein.
     * @param d Datenelement
     * @return (neuer) Nachfolger des Vorg&auml;ngers
     */
    LISTENELEMENT Anfuegen (DATENELEMENT d)
    {
        return new KNOTEN (this, d);
    }
    
    /**
     * Sucht das angegebene Datenelement.
     * @param wert Schl&uuml;ssel f&uuml;r das Element.
     * @return Referenz auf das gefundene Element oder null.
     */
    DATENELEMENT Suchen (String wert)
    {
        return null;
    }

    /**
     * Sucht das Datenelement mit dem kleinsten Wert.
     * @return Referenz auf das Datenelement oder null.
     */
    DATENELEMENT MinimumSuchen ()
    {
        return null;
    }
    
    /**
     * L&ouml;scht den Eintrag mit dem Datenelement aus der Liste.
     * @param d Datenelement
     * @return (neuer) Nachfolger des Vorg&auml;ngers
     */
    LISTENELEMENT Loeschen (DATENELEMENT d)
    {
        return this;
    }
    
    /**
     * F&uuml;hrt die Kopie in eine Feld durch.
     * Erzeugt das Feld.
     * @param anzahl Anzahl der bisher gez&auml;hlten Elemente.
     * @return Feld mit den Datenreferenzen
     */
    DATENELEMENT [] Kopieren (int anzahl)
    {
        return new DATENELEMENT [anzahl];
    }
    
    /**
     * Erzeugt eine Kopie des Listenelements und der Liste ab hier.
     * Die Datenelemente werden nicht kopiert.
     * Auf Verwendung von Object. clone wurde bewusst verzichtet.
     * @return Kopie des Listenelements mit Referenz auf kopierte Nachfolger
     */
    LISTENELEMENT Kopieren ()
    {
        return new ABSCHLUSS ();
    }
}
