
/**
 * Allgemeines Element einer Liste von Datenelementen.
 * 
 * @author 
 * @version 1.0
 */
abstract class LISTENELEMENT
{
    /**
     * Der Konstruktor ist nur der Vollst&auml;ndigkeit halber angegeben.
     */
    LISTENELEMENT ()
    {
        // (noch) nichts zu tun
    }
    
    /**
     * F&uuml;gt das Datenelement als letztes in die Liste ein.
     * @param d Datenelement
     * @return (neuer) Nachfolger des Vorg&auml;ngers
     */
    abstract LISTENELEMENT Anfuegen (DATENELEMENT d);

    /**
     * Sucht das angegebene Datenelement.
     * @param wert Schl&uuml;ssel f&uuml;r das Element.
     * @return Referenz auf das gefundene Element oder null.
     */
    abstract DATENELEMENT Suchen (String wert);

    /**
     * Sucht das Datenelement mit dem kleinsten Wert.
     * @return Referenz auf das Datenelement oder null.
     */
    abstract DATENELEMENT MinimumSuchen ();
    
    /**
     * L&ouml;scht den Eintrag mit dem Datenelement aus der Liste.
     * @param d Datenelement
     * @return (neuer) Nachfolger des Vorg&auml;ngers
     */
    abstract LISTENELEMENT Loeschen (DATENELEMENT d);
    
    /**
     * F&uuml;hrt die Kopie in eine Feld durch.
     * @param anzahl Anzahl der bisher gez&auml;hlten Elemente.
     * @return Feld mit den Datenreferenzen
     */
    abstract DATENELEMENT [] Kopieren (int anzahl);
    
    /**
     * Erzeugt eine Kopie des Listenelements und der Liste ab hier.
     * Die Datenelemente werden nicht kopiert.
     * Auf Verwendung von Object. clone wurde bewusst verzichtet.
     * @return Kopie des Listenelements mit Referenz auf kopierte Nachfolger
     */
    abstract LISTENELEMENT Kopieren ();
}
