
/**
 * Beschreibt die Bedienoberfl&auml;che.
 * 
 * @author 
 * @version 1.0
 */

import java. awt. *;
import java. awt. event. *;
import javax.swing.*;

class OBERFLAECHE implements STATUSBEOBACHTER
{
    private JComponent karte;
    private JFrame fenster;
    private JComboBox startOrt;
    private JComboBox zielOrt;
    private JLabel status;
    private JList ortInfos;
    private JList wegInfos;
    private KONTROLLEUR kontrolleur;

    /**
     * Legt die Oberfl&auml;chenelemente an.
     * @param karte Die Komponente zur Darstellung der Karte.
     * @param orte Feld mit den Orten, nutzt ort. toString ()
     * @param ortInfo Feld mit den Ortsinformationen
     * @param wegInfo Feld mit den Weginformationen
     */
    OBERFLAECHE (JComponent karte, Object [] orte, String [] ortInfo, String [] wegInfo, KONTROLLEUR k)
    {
        this. karte = karte;
        kontrolleur = k;
        KomponentenAnlegen (orte, ortInfo, wegInfo);
        
    }
    
    /**
     * Vereinbarung der Oberfl&auml;chenkomponenten.
     * @param orte Feld mit den Orten, nutzt ort. toString ()
     * @param ortInfo Feld mit den Ortsinformationen
     * @param wegInfo Feld mit den Weginformationen
     */
    private void KomponentenAnlegen (Object [] orte, String [] ortInfo, String [] wegInfo)
    {
        JPanel content;
        JButton button;
        JLabel l;
        JScrollPane scroll;

        fenster = new JFrame ("Fahrradroutenplaner");
        fenster. setResizable (false);
        fenster. addWindowListener (new WindowAdapter () {
            public void windowClosing (WindowEvent evt) {
                kontrolleur. Beenden ();
            }
        });
        content = (JPanel) fenster. getContentPane ();
        content. setLayout (null);

        button = new JButton ("Route berechnen");
        content. add (button);
        button. setBounds (300, 35, 160, 30);
        button. addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                kontrolleur. WegBerechnen (startOrt. getSelectedItem (), zielOrt. getSelectedItem ());
            }
        });
        button = new JButton ("Beenden");
        content. add (button);
        button. setBounds (650, 35, 160, 30);
        button. addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                kontrolleur. Beenden ();
            }
        });

        l = new JLabel ("Startort:");
        content. add (l);
        l. setBounds (20, 20, 90, 20);
        l = new JLabel ("Zielort:");
        content. add (l);
        l. setBounds (20, 60, 90, 20);
        startOrt = new JComboBox (orte);
        content. add (startOrt);
        startOrt. setBackground (new Color (0, 153, 51));
        startOrt. setBounds (120, 15, 150, 30);
        zielOrt = new JComboBox (orte);
        content. add (zielOrt);
        zielOrt. setBackground (new Color (240, 0, 0));
        zielOrt. setBounds (120, 55, 150, 30);
        ortInfos = new JList (ortInfo);
        scroll = new JScrollPane (ortInfos);
        content. add (scroll);
        scroll. setPreferredSize (new Dimension (400, 400));
        scroll. setBounds (420, 310, 400, 200);
        wegInfos = new JList (wegInfo);
        scroll = new JScrollPane (wegInfos);
        content. add (scroll);
        scroll. setPreferredSize (new Dimension (400, 400));
        scroll. setBounds (420, 100, 400, 200);
        status = new JLabel ("");
        content. add (status);
        status. setBounds (20, 540, 790, 20);
        
        content. add (karte);
        karte. setBounds (10, 100, 400, 410);
        
        fenster. setSize (830, 600);
        fenster. setVisible (true);
    }

    /**
     * Empf&auml;ngt Statusmeldungen
     * @param text Text der Statusmeldungen
     */
    public void StatusSetzen (String text)
    {
        status. setText (text);
    }

    /**
     * Empf&auml;ngt die Vorg&auml;ngerinformation, Start und Ziel
     * @param vorgaenger Liste mit der Vorg&auml;ngerinformation
     * @param start Name des Startortes
     * @param ziel Name des Zielortes
     */
    public void WegSetzen (LISTE vorgaenger, String start, String ziel)
    {
        // nix
    }
}
