
/**
 * Verwaltet die Vorg&auml;ngerinformation f&uuml;r dem Dijkstra-Algorithmus.
 * 
 * @author
 * @version 1.0
 */
class VORGAENGERINFO implements DATENELEMENT
{
    private ORT ort;
    private ORT vorgaenger;
    private int gesamtLaenge;
    
    /**
     * Besetzt die Attribute.
     * @param o aktueller Ort
     * @param v Vorg&auml;ner
     * @param laenge Wegl&auml;nge bis hierher
     */
    VORGAENGERINFO (ORT o, ORT v, int laenge)
    {
        ort = o;
        vorgaenger = v;
        gesamtLaenge = laenge;
    }
    
    /**
     * Meldet den Ort.
     * @return Ort
     */
    ORT OrtGeben ()
    {
        return ort;
    }
    
    /**
     * Meldet den Vorg&auml;nger.
     * @return Vorg&auml;nger
     */
    ORT VorgaengerGeben ()
    {
        return vorgaenger;
    }
    
    /**
     * Meldet die aktuelle Weglaenge bis hierher.
     * @return Gesamtl&auml;nge
     */
    int LaengeGeben ()
    {
        return gesamtLaenge;
    }
    
    /**
     * Setzt den Vorg&auml;nger auf einen neuen Wert.
     * @param v Vorg&auml;ner
     */
    void VorgaengerSetzen (ORT v)
    {
        vorgaenger = v;
    }
    
    /**
     * Setzt die Gesamtwegl&auml;nge auf einen neuen Wert.
     * @param laenge Wegl&auml;nge bis hierher
     */
    void LaengeSetzen (int laenge)
    {
        gesamtLaenge = laenge;
    }

    /**
     * Identifiziert das Element.
     * @param wert der Vergleichswert.
     * @return true, wenn der Ortsname gleich dem Vergleichswert ist.
     */
    public boolean IstGleich (String wert)
    {
        return ort. IstGleich (wert);
    }

    /**
     * Implementiert die Kleiner-Relation f&uuml;r die Minimumsuche.
     * @param d Datenelement mit dem Vergleichswert.
     * @return true, wenn das Element eine kleinere Gesamtlaenge hat als der Vergleichswert.
     */
    public boolean IstKleiner (DATENELEMENT d)
    {
        return (d == null) || (d instanceof VORGAENGERINFO) && (gesamtLaenge < ((VORGAENGERINFO) d). gesamtLaenge);
    }
}
