
/**
 * Beschreibt ein allgemeines Element des Baums.
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
abstract class BAUMELEMENT
{

    /**
     * Der Konstruktor ist aus Dokumentationsgr&uuml;nden vorhanden
     */
    BAUMELEMENT()
    {
        // keine spezielle Aufgabe
    }

    /**
     * Sucht im Baum nach dem gegebenen Datenelelement.
     * @param wert Referenz auf ein Datenelement mit dem Vergleichswert
     * @return Referenz auf das Datenelement, wenn der Wert gefunden wurde<br>null: sonst
     */
    abstract DATENELEMENT Suchen (DATENELEMENT wert);

    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * Der Wert darf noch nicht vorkommen
     * @param wert Referenz auf das einzuf&uuml;gende Datenelement
     */
    abstract BAUMELEMENT Einfuegen (DATENELEMENT wert);
    
    /**
     * Durchl&auml;ft den Baum in Preorder
     */
    abstract void PreOrder ();
    
    /**
     * Durchl&auml;ft den Baum in Inorder
     */
    abstract void InOrder ();
    
    /**
     * Durchl&auml;ft den Baum in Postorder
     */
    abstract void PostOrder ();
}
