// Grundaufgabe: Rechenterm-Umwandlung Infix-Notation --> Postfix-Notation
// Vertiefungsaufgabe: Ausrechnen eines Terms in Postfix-Notation

class UMWANDLER
{
    // Attribute
    private String termInInfixnotation;
    private String termInPostfixnotation;
    private STAPEL stapel;

    // Konstruktor
    UMWANDLER() {
        stapel = new STAPEL();
    }
    
    // Methoden 
    /** 
     * Eingabe eines Terms als String in Infix-Notation 
     * Aus Einfachheitsgr&uuml;nden sind nur die Zahlen 0 bis 9 bzw. einbuchstabige Variablen zulssig!
     * @param Term in Infix-Notation
     * 
     */  
   void TermInInfixNotationEingeben(String term) {
        termInInfixnotation = term;
    }
    
     /** 
     * Eingabe eines Terms als String in Postfix-Notation 
     * Aus Einfachheitsgrnden sind nur die Zahlen 0 bis 9 bzw. einbuchstabige Variablen zulssig!
     * Methode ist ntzlich bei Vertiefungsaufgabe 2
     * @param Term in Postfix-Notation
     */  
   void TermInPostfixnotationEingeben(String term) {
        termInPostfixnotation = term;
    }
    
     /** 
     * Umwandlung des in termInInfixnotation abgespeicherten Terms in die Postfix-Notation und Abspeicherung des Ergebnisses in termInPostfixnotation
     * Ber&uuml;sichtigt ist nun der Rang des Rechenzeichens, d.h. Punkt vor Strich und gleichwertige Rechenzeichen von links nach rechts
    */  
     void InInfixnotationUmwandeln() {
        String term = termInInfixnotation;
        termInPostfixnotation ="";
        ZEICHEN z, oberstesZeichen;
        // Lokale Hilfsvariable fr die Abspeicherung des Indexes des momentan betrachteten Zeichens von termInInfixnotation
        int zeichenposition = 0;
        while (zeichenposition < term.length()) {
            // Momentan untersuchtes Zeichen der Zeichenkette term_in_infixnotation
            char zeichen = term.charAt(zeichenposition);
            zeichenposition = zeichenposition + 1;
           
            switch (zeichen)
            {
              // Ist das Zeichen eine ffnende Klammer, lege es auf den Stack
              case '(': 
                 z = new ZEICHEN(zeichen);
                 stapel.Einfuegen(z);
                 break;
              case '+': case '-': case '/': case '*': 
                 // Falls der Stapel leer ist...
                 if (stapel.IstLeer()) {
                        z = new ZEICHEN(zeichen);
                        stapel.Einfuegen(z);
                 } else {
                     // Falls der Rang von zeichen hoeher ist ...
                     if (RechenzeichenrangIstHoeher(zeichen)) {
                        z = new ZEICHEN(zeichen);
                        stapel.Einfuegen(z);
                     } else {
                          // Falls das oberste Zeichen ein Rechenzeichen ist ... 
                          if(OberstesZeichenIstRechenzeichen()) {
                                oberstesZeichen = (ZEICHEN) stapel.Entfernen();
                                termInPostfixnotation = termInPostfixnotation + oberstesZeichen.WertGeben();
                          }   
                          // Solange das oberste Zeichen ein hoeherrangiges Rechenzeichen ist ...
                          while (!stapel.IstLeer() && !RechenzeichenrangIstHoeher(zeichen) && OberstesZeichenIstRechenzeichen()) {
                                oberstesZeichen = (ZEICHEN) stapel.Entfernen();
                                termInPostfixnotation = termInPostfixnotation + oberstesZeichen.WertGeben();
                          }
                          // Rang von zeichen ist nun hoeher
                          z = new ZEICHEN(zeichen);
                          stapel.Einfuegen(z);
                        }
                  }      
                 break;  
              // Ist das Zeichen eine schlieende Klammer, so nimm solange Zeichen vom Stack und hnge sie an die Zeichenkette term_in_postfixnotation, bis eine ffende Klammer oben auf dem Stack liegt
              case ')':
                 z = (ZEICHEN) stapel.Entfernen();
                 while (z.WertGeben() != '(') {
                     termInPostfixnotation = termInPostfixnotation + z.WertGeben();
                     z = (ZEICHEN) stapel.Entfernen();
                 }
                 break;
                 // Ansonsten muss das Zeichen eine Zahl oder eine Variable sein...
              default:  
                 termInPostfixnotation = termInPostfixnotation + zeichen;
                 break;   
              }
         }
        // Leeren des Stapels
        while (!stapel.IstLeer()) {
            z = (ZEICHEN) stapel.Entfernen();
            termInPostfixnotation = termInPostfixnotation + z.WertGeben();
        } 
        ErgebnisAusgeben();
   } 
   
    /** pr&uuml;ft, ob das &uuml;bergebene Rechenzeichen einen h&ouml;heren Rang hat als das Zeichen, das ganz oben auf dem Stapel liegt
     * Es handelt sich um eine interne Hilfsmethode
     * Es wird ebenfalls true zur&uuml;ckgegeben, wenn der Stapel leer ist, weil das auch als H&ouml;herrangigkeit des &uuml;bergebenen Rechenzeichens interpretiert werden kann 
     * Die Methode ist private gesetzt, da sie nur zur interne Pr&uuml;fung notwendig ist
     * @param das eingelesene Rechenzeichen
     */
     private boolean RechenzeichenrangIstHoeher(char zeichen) {
        ZEICHEN oberstesElement = (ZEICHEN) stapel.OberstesDatenelementGeben();
        // falls zeichen * oder / und das oberste Element + und -, liegt Hoeherrangigkeit vor, ansonsten nicht
        return  ((zeichen == '*' || zeichen == '/') && (oberstesElement.WertGeben() == '+' || oberstesElement.WertGeben() == '-')); 
     }   
    
    /** pr&uuml;ft, ob das oberste Zeichen des Stapels ein Rechenzeichen oder nicht (d.h. es muss sich dann um eine Klammer handeln) ist
     * Es handelt sich um eine interne Hilfsmethode
    */
     private boolean OberstesZeichenIstRechenzeichen() {
         ZEICHEN oberstesElement = (ZEICHEN) stapel.OberstesDatenelementGeben();
         switch (oberstesElement.WertGeben()) {
              case '+': case '-': case '/': case '*': 
                return true;
              default:
                return false; 
           }
    }   
   
   /**
    * Ausgabe des Umwandlungsergebnisses
    */
   private void ErgebnisAusgeben() {
       System.out.println(termInInfixnotation + " --> " + termInPostfixnotation);
   }
   
   /**
    * Ausrechnen eines (variablenfreien) Terms, der in Postfix-Notation vorliegt!
    * Vertiefungsaufgabe 2
    */
     void TermAusrechnen() {
        String term = termInPostfixnotation;
        int ergebnis = 0;
        int zeichenposition = 0;
        ZAHL z, operand1, operand2;
        while (zeichenposition < term.length()) {
            // Momentan untersuchtes Zeichen der Zeichenkette term_in_postfixnotation
            char zeichen = term.charAt(zeichenposition);
            zeichenposition = zeichenposition + 1;
            switch (zeichen)
            {
              // Das Zeichen ist ein Operationszeichen  
              case '+': case '-': case '/': case '*': 
                 operand2 = (ZAHL) stapel.Entfernen();
                 operand1 = (ZAHL) stapel.Entfernen();
                 // Berechnung des Ergebnisses mit dem richtigen Operanden
                 // Operand ist als Charakter abgespeichert und muss deshalb richtig "konvertiert" werden.
                 if (zeichen == '+') {
                     ergebnis =  operand1.WertGeben() +  operand2.WertGeben();
                    } 
                 if (zeichen == '*') {
                     ergebnis =  operand1.WertGeben() *  operand2.WertGeben();
                    }
                 if (zeichen == '/') {
                     ergebnis =  operand1.WertGeben() /  operand2.WertGeben();
                    }
                 if (zeichen == '-') {
                     ergebnis =  operand1.WertGeben() -  operand2.WertGeben();
                    }
                 z = new ZAHL(ergebnis);
                 stapel.Einfuegen(z);
                 break;  
              // sonst muss das Zeichen eine Zahl sein 
              default:  
              //  Konvertierung char --> int liefert ASCII-Code; Subtraktion des ASCII-Codes des Zeichens '0' liefert die "richtige" Konvertierung
                    z = new ZAHL(zeichen -'0');
                    System.out.println(z.WertGeben());
                    stapel.Einfuegen(z);
               // }   
                 break;   
              }
             
        }
        // Holen des Endergebnisses vom Stapel
            z = (ZAHL) stapel.Entfernen();
            System.out.println(termInPostfixnotation + " = " + z.WertGeben());
   } 

   
  
    
}       

