
/**
 * Verwaltet einen Knoten des Baums.
 * 
 * @author ISB-Arbeitskreis
 * @version 1.0
 */
class KNOTEN_BAUM extends BAUMELEMENT
{
    /** Referenz auf den linken Nachfolger */
    private BAUMELEMENT linkerNachfolger;
    /** Referenz auf den rechten Nachfolger */
    private BAUMELEMENT rechterNachfolger;
    /** Referenz auf das Datenelement */
    private DATENELEMENT daten;

    /**
     * Erzeugt einen Knoten mit den dem angegebenen Datenelement.
     * @param d Referenz auf das verwaltete Datenelement
     */
    KNOTEN_BAUM(DATENELEMENT d)
    {
        super ();
        linkerNachfolger = new ABSCHLUSS_BAUM ();
        rechterNachfolger = new ABSCHLUSS_BAUM ();
        daten = d;
    }
    
   
    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * Der Wert darf noch nicht vorkommen
     * @param wert Referenz auf das einzuf&uuml;gende Datenelement
     * @return der (neue) Nachfolger des Aufrufers
     */
    void LinksEinfuegen (BAUM b)
    {
        linkerNachfolger= b.WurzelGeben();
       
    }
    
     void RechtsEinfuegen (BAUM b)
    {
        rechterNachfolger= b.WurzelGeben();
        
    }
    
    /**
     * Durchl&auml;ft den Baum in Preorder
     */
    void PreOrder ()
    {
        daten. Ausgeben ();
        linkerNachfolger. PreOrder ();
        rechterNachfolger. PreOrder ();
    }
    
    /**
     * Durchl&auml;ft den Baum in Inorder
     */
    void InOrder ()
    {
        linkerNachfolger. InOrder ();
        daten. Ausgeben ();
        rechterNachfolger. InOrder ();
    }
    
    /**
     * Durchl&auml;ft den Baum in Postorder
     */
    void PostOrder ()
    {
        linkerNachfolger. PostOrder ();
        rechterNachfolger. PostOrder ();
        daten. Ausgeben ();
    }

}
