class RANGIERBAHNHOF
{
    // Attribute
    private STAPEL gleis1, gleis2, gleis3;

    // Konstruktor
    RANGIERBAHNHOF() 
    {
        // Erzeugung der Gleise
        gleis1 = new STAPEL();
        gleis2 = new STAPEL();
        gleis3 = new STAPEL();
        // Belegung des Gleises A mit Waggons
        WaggonAufstellen(3);
        WaggonAufstellen(2);
        WaggonAufstellen(1);
        WaggonAufstellen(4);
    }
    
    // Methoden
    /** 
     * erzeugt einen neuen Waggon mit der gew&uuml;schten Nummer (im sortierten Zug) setzt ihn auf Gleis 1
     * @param gew&uuml;schten Nummer (im sortierten Zug von der Lok aus gesehen)
     */
   
    void WaggonAufstellen(int nummer) 
    {
        DATENELEMENT waggon = new WAGGON(nummer);
        gleis1.Einfuegen(waggon);
    }
    
    /** 
     * gibt die aktuelle Belegung aller drei Gleise aus
    */
    void AktuelleSituationGeben() 
    {
        System.out.print ("Gleis 1: ");
        gleis1.AlleAusgeben();
        System.out.println ();
        System.out.print ("Gleis 2: ");
        gleis2.AlleAusgeben();
        System.out.println ();
        System.out.print ("Gleis 3: ");
        gleis3.AlleAusgeben();
        System.out.println ();
        System.out.println ("--------------------------------------------------------------");
   }    
   
    /** 
     * f&uuml;hrt den Rangiervorgang nach dem ersten Algorithmus aus Aufgabe 'Rangierbahnhof - Abge&auml;derte Situation'aus
    */
   void Rangieren() 
   {
      int anzahlschritte = 0;
      DATENELEMENT waggon;
      
      while (!gleis1.IstLeer() ) {
            while (!gleis1.IstLeer() ) { 
                if (gleis3.IstLeer()) {
                     waggon = gleis1.Entfernen();
                     gleis3.Einfuegen(waggon);
                } else {
                    if (gleis1.AnfangGeben().SchluesselIstKleiner(gleis3.AnfangGeben())){
                        waggon = gleis1.Entfernen();
                        gleis3.Einfuegen(waggon);
                    } else {
                        waggon = gleis3.Entfernen();
                        gleis2.Einfuegen(waggon);
                    }
                }   
                AktuelleSituationGeben(); 
                anzahlschritte = anzahlschritte + 1;
            }
            // Gleis 1 leer und Gleis 2 nicht leer --> Verschiebe alle Waggons von Gleis 2 auf Gleis 1
            while (!gleis2.IstLeer() ) {
                waggon = gleis2.Entfernen();
                gleis1.Einfuegen(waggon);
                AktuelleSituationGeben(); 
                anzahlschritte = anzahlschritte + 1;
            }
        }   
        System.out.println("Anzahl der Rangierschritte: " + anzahlschritte);
    }
    
     /** 
     * f&uuml;hrt den Rangiervorgang nach dem optimierten Algorithmus aus Aufgabe 'Rangierbahnhof - Abge&auml;derte Situation'aus
    */
    void RangierenBesser() {
        int anzahlschritte = 0;
        DATENELEMENT waggon;
        STAPEL startgleis = gleis1;
        // Hilfsvariable zum Vertauschen zweier Werte
        STAPEL hilfsgleis = gleis2;
         while (!startgleis.IstLeer() ) {
            while (!startgleis.IstLeer() ) { 
                if (gleis3.IstLeer()) {
                     waggon = startgleis.Entfernen();
                     gleis3.Einfuegen(waggon);
                } else {
                    if (startgleis.AnfangGeben().SchluesselIstKleiner(gleis3.AnfangGeben())){
                        waggon = startgleis.Entfernen();
                        gleis3.Einfuegen(waggon);
                    } else {
                        waggon = gleis3.Entfernen();
                        hilfsgleis.Einfuegen(waggon);
                    }
                }   
                AktuelleSituationGeben(); 
                anzahlschritte = anzahlschritte + 1;
            }
            if (!hilfsgleis.IstLeer() ) {
                STAPEL tausch = hilfsgleis;
                hilfsgleis = startgleis;
                startgleis = tausch;
            }
                   
        }   
        System.out.println("Anzahl der Rangierschritte: " + anzahlschritte);
    }
    
    
    
}    